# n은 후보자 전체 수, r은 관찰할 사람 수
# 알고리즘은 다음과 같다.
# r명까지는 고르지 않고 최댓값만 기억
# r+1명째 이후에 그 최댓값을 넘는 최초의 사람을 선택


###### 함수 select 정의 ####### 
select <- function(n, r){
	# n은 후보자 전체 수, r은 관찰할 사람 수
	applicants <- runif(n) # n명만큼 난수 발생
	candidate <- max(applicants[1:r]) # r명까지의 candidate(잠정 1위)를 정의
	if(candidate == max(applicants)){
		selected <- 0
	}
	# 최초 r명에 전체 1위가 있다면 실패
	# selected에 0 대입

	s <- r + 1 # while 루프용 카운터로 s 정의
	if(applicants[s] > candidate) {   # r번째 이후인 사람 > r번째까지의 잠정 1위를 비교
		selected <- applicants[s] # 잠정 1위를 넘는 사람을 selected에 대입
	} else {
		selected <- 0
		while(candidate != max(applicants) & applicants[s] < candidate & s<=n){
			s <- s+1
			selected <- applicants[s]
			# candidate보다 좋은 사람이 나타날 때까지 검색을 계속
			# candidate보다 좋은 사람이 나타나면 기록
		}#while ends
	}#if else ends
	if(selected == max(applicants)){1}else{0}# selected 전체의 1위인지를 판정
}# 결과를 0이나 1로 반환하고 종료


###### 동작 확인 #######
select(10,3)

# 1000번 반복하여 확률을 계산
mean(replicate(1000,select(10,3)))

mean(replicate(1000,select(100,37)))

# 평균(성공 확률) 분포
hist(
	replicate(100, mean(replicate(1000,select(1000,368))))
)


